#ifndef ERROR_CODE_MANAGER_H_
#define ERROR_CODE_MANAGER_H_

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"

typedef int32_t ErrorCode;
typedef int32_t ErrorCode_t;

#define INDHILIB_OK 0
#define INDHILIB_ERROR_VALIDATION_FAILED -1
#define INDHILIB_INVALID_DEVICE_NAME -2
#define INDHILIB_INIT_FAILED -3
#define INDHILIB_DEINIT_FAILED -4
#define INDHILIB_FEATURE_ID_ALREADY_EXIST -5
#define INDHILIB_FEATURE_ID_INVALID -6
#define INDHILIB_FEATURE_NAME_ALREADY_EXIST -7
#define INDHILIB_FEATURE_NAME_INVALID -8
#define INDHILIB_FEATUTE_TYPE_INVALID -9
#define INDHILIB_FEATUTE_VERSION_INVALID -10
#define INDHILIB_MAX_FEATURE -11
#define INDHILIB_FEATURE_DOES_NOT_EXIST -12
#define INDHILIB_NVS_INIT_FAILED -13
#define INDHILIB_NETWORKING_FAILED -14
#define INDHILIB_EVENT_MANAGER_INIT_FAILED -15
#define INDHILIB_WIFI_START_FAILED -46
#define INDHILIB_WIFI_AP_INIT_FAILED -17
#define INDHILIB_WIFI_AP_DEINIT_FAILED -55
#define INDHILIB_WIFI_STA_INIT_FAILED -18
#define INDHILIB_PING_INIT_FAILED -19
#define INDHILIB_PING_DEINIT_FAILED -20
#define INDHILIB_WIFI_STA_START_FAILED -21
#define INDHILIB_WIFI_AP_START_FAILED -22
#define INDHILIB_WIFI_AP_STOP_FAILED -23
#define INDHILIB_PROVISIONING_INIT_FAILED -47
#define INDHILIB_PROVISIONING_DEINIT_FAILED -56
#define INDHILIB_BLE_PROVISIONING_INIT_FAILED -24
#define INDHILIB_BLE_PROVISIONING_DEINIT_FAILED -25
#define INDHILIB_AP_IP_MODIFY_FAILED -26
#define INDHILIB_AP_CONFIG_FAILED -27
#define INDHILIB_API_SERVER_INIT_FAILED -28
#define INDHILIB_API_SERVER_START_FAILED -29
#define INDHILIB_API_SERVER_STOP_FAILED -30
#define INDHILIB_API_SERVER_DEINIT_FAILED -31
#define INDHILIB_API_CLIENT_VALIDATION_INIT_FAILED -32
#define INDHILIB_API_CLIENT_VALIDATION_DEINIT_FAILED -33
#define INDHILIB_API_CLIENT_VALIDATION_FAILED -34
#define INDHILIB_API_CLIENT_DEVICE_INIT_INIT_FAILED -35
#define INDHILIB_API_CLIENT_DEVICE_INIT_DEINIT_FAILED -36
#define INDHILIB_API_CLIENT_DEVICE_INIT_FAILED -37
#define INDHILIB_MQTT_INIT_FAILED -38
#define INDHILIB_MQTT_DEINIT_FAILED -39
#define INDHILIB_MQTT_START_FAILED -40
#define INDHILIB_MQTT_STOP_FAILED -41
#define INDHILIB_MQTT_ACTIVATION_FAILED -42
#define INDHILIB_NVS_STA_CRED_SAVE_FAILED -43
#define INDHILIB_NVS_INIT_ENDP_SAVE_FAILED -44
#define INDHILIB_NVS_API_KEY_SAVE_FAILED -45
#define INDHILIB_ROUTER_SSID_INVALID -50
#define INDHILIB_ROUTER_PSK_INVALID -51
#define INDHILIB_TOKEN_INVALID -54
#define INDHILIB_AP_SSID_INVALID -61
#define INDHILIB_AP_PSK_INVALID -62
#define INDHILIB_CODE_DEVICE_NAME_ERROR -63
#define INDHILIB_CODE_ONBOARDING_METHOD_INVALID -64
#define INDHILIB_DEVICE_BLE_NAME_ERROR -65
#define INDHILIB_DEVICE_WIFI_AP_ERROR -66
#define INDHILIB_DEVICE_ONBOARDING_TOKEN_ERROR -67
#define INDHILIB_ROUTER_SSID_ERROR -68
#define INDHILIB_ROUTER_PASSWORD_ERROR -69
#define INDHILIB_WIFI_STA_STOP_FAILED -70
#define INDHILIB_WIFI_STA_DEINIT_FAILED -71
#define INDHILIB_WIFI_INIT_FAILED -72
#define INDHILIB_NVS_DEINIT_FAILED -73
#define INDHILIB_MQTT_EVENT_MANAGER_REGISTER_FAILED -74
#define INDHILIB_WIFI_EVENT_MANAGER_REGISTER_FAILED -75
#define INDHILIB_IP_EVENT_MANAGER_REGISTER_FAILED -76
#define INDHILIB_WIFI_DEINIT_FAILED -77
#define INDHILIB_WIFI_STOP_FAILED -78
#define INDHILIB_WIFI_STA_DISCONNECT_FAILED -79
#define INDHILIB_MQTT_EVENT_MANAGER_UNREGISTER_FAILED -80
#define INDHILIB_WIFI_EVENT_MANAGER_UNREGISTER_FAILED -81
#define INDHILIB_IP_EVENT_MANAGER_UNREGISTER_FAILED -82
#define INDHILIB_EVENT_MANAGER_DEINIT_FAILED -83
#define INDHILIB_WIFI_STA_CONNECT_FAILED -84
#define INDHILIB_DEVICE_DECONFIGURE -85
#define INDHILIB_DEVICE_ACTIVATION_TIMEOUT -86
#define INDHILIB_APP_ONBAORDING_FAILED -87
#define INDHILIB_INVALID_DEVICE_ID -88
#define INDHILIB_MESSAGING_INIT_FAILED -89
#define INDHILIB_MESSAGING_DEINIT_FAILED -90
#define INDHILIB_MESSAGING_START_FAILED -91
#define INDHILIB_MESSAGING_STOP_FAILED -92
#endif